﻿-- Author      : Alistair
-- Create Date : 7/26/2008 8:21:56 PM

local AUF_Events = {"UNIT_HEALTH", "UNIT_MAXHEALTH",
							"UNIT_MANA", "UNIT_MAXMANA",
							"UNIT_ENERGY", "UNIT_MAXENERGY", 
							"UNIT_RAGE", "UNIT_MAXRAGE",
							"PLAYER_ENTERING_WORLD", "UNIT_DISPLAYPOWER",
							"PARTY_MEMBERS_CHANGED", "PARTY_MEMBER_ENABLE",
							"PARTY_MEMBER_DISABLE", "UNIT_NAME_UPDATE",
							"UNIT_PORTRAIT_UPDATE",	"UNIT_FACTION",
							"UNIT_LEVEL", "UNIT_COMBAT",
					}
					
local auf_party = {}

function  AuraUnitFrames_PartyDropDownOnLoad(self)
		UIDropDownMenu_Initialize(self, AuraUnitFramesDropDown_PartyInitialize, "MENU")
end

function AuraUnitFramesDropDown_PartyInitialize()
	local dropdown
	if ( UIDROPDOWNMENU_OPEN_MENU ) then
		dropdown = getglobal(UIDROPDOWNMENU_OPEN_MENU)
	else
		dropdown = this
	end
	UnitPopup_ShowMenu(dropdown, "PARTY",  dropdown:GetAttribute("unit"))
end

function AuraUnitFramesParty_OnLoad(self)
	
	self:SetAttribute("type1", "target")
	local unitid = self:GetAttribute("unit")
	
	self.showmenu = function()
		ToggleDropDownMenu(1, nil, _G["AuraUnitFrames_Party"..self:GetID().."DropDownMenu"], self)
	end
	SecureUnitButton_OnLoad(self, unitid, self.showmenu)
	
	AuraUnitFrames_SetChildren(self ,unitid )
	
	
	
	for i = 1, 4 do
		AuraUnitFrames_DisableFrame(getglobal("PartyMemberFrame"..i))	
	end
	
	--Set up the statusbar events, should be listening for all that will effect any statusbar. Wont matter how many we add
	--As a mana bar will only ever look for rage/energy/rage events not hp ones
	for i,event in ipairs(AUF_Events) do 
		self:RegisterEvent(event)   
	end	

	--set up the buffframes
	name = (self:GetName()):match("_%a+%d")
	--set up the buff frames
	buffframe = CreateFrame("Frame", "AuraUnitFrames"..name.."BuffFrame", self, "AuraUnitFrames_BuffFrameTemplate")
	AuraUnitFramesBuffs_SetUpValues(buffframe, unitid)

	--get the frames name and set up all its shortcuts
	self.healthbar = _G[self:GetName().."_HealthBar"]
	self.manabar = _G[self:GetName().."_ManaBar"]
	self.healthbartext = _G[self.healthbar:GetName().."_Text"]
	self.manabartext = _G[self.manabar:GetName().."_Text"]
	self.unitnametext = _G[self:GetName().."_Name".."_Text"]
	self.unitleveltext= _G[self:GetName().."_Level".."_Text"]
	self.pvpicon = _G[self:GetName().."_PvP".."_Icon"]
	self.portrait = _G[self:GetName().."_Portrait".."_Picture"]
	self.hitindicator = _G[self:GetName().."_HitIndicator".."_Overlay"]
	
	CombatFeedback_Initialize(self.hitindicator, 20)
	--by default the frame will not be shown, allows us to not have it try and update a hidden bar
	self.shown = false 
	

	self.partyID = "party"..self:GetID()
	auf_party[self.partyID] = self
		
end

function AuraUnitFramesParty_OnEvent(self, event, ...)
	
	local selfunit = self.partyID	
			
	if event == "PARTY_MEMBER_ENABLE" or event == "PARTY_MEMBER_DISABLE" or event == "PLAYER_ENTERING_WORLD" or event == "PARTY_MEMBERS_CHANGED" then
		AuraUnitFramesParty_UpdateMembers(self)
	elseif event == "UNIT_PORTRAIT_CHANGED" then
		local unit = ...
		SetPortraitTexture(self.portrait, unit)
	elseif event == "UNIT_COMBAT" then
		if select(1,...) == selfunit then
			CombatFeedback_OnCombatEvent(select(2,...), select(3,...), select(4,...), select(5,...))
		end
	else	
		--if arg1 = a unit then we do something otherwise do nothing
		local unit = ...
		if selfunit == unit then
			if event == "UNIT_MAXHEALTH"  or event == "UNIT_HEALTH" then
				if self.shown then
					AuraUnitFrames_UpdateHealth(self,unit)
				end
			elseif event == "UNIT_MANA" or event == "UNIT_ENERGY" or event == "UNIT_RAGE" or
				event == "UNIT_MAXMANA" or event == "UNIT_MAXENERGY" or event == "UNIT_MAXRAGE"  then
				if self.shown then
					AuraUnitFrames_UpdateMana(self,unit)
				end
			elseif event == "UNIT_DISPLAYPOWER" then
				if self.shown then
					AuraUnitFrames_UpdatePowerType(self,unit)
				end
			elseif event == "UNIT_NAME_UPDATE" then
				AuraUnitFrames_UpdateName(self,unit)
			elseif event ==	"UNIT_FACTION" then
				AuraUnitFrames_UpdateFaction(self,unit)
			elseif event == "UNIT_LEVEL" then
				AuraUnitFrames_UpdateLevel(self, unit)
			elseif event == "UNIT_PORTRAIT_UPDATE" then
				SetPortraitTexture(self.portrait, unit)
			end
		end
	end
	
end

function AuraUnitFramesParty_UpdateMembers(self)
	
	for unitid, frame in pairs(auf_party) do
		if UnitExists(unitid) then
			--if the unit exists (didn't leave the party) then set the frame to shown and update the bars
			frame:SetAlpha(1)
			frame.shown = true
			AuraUnitFrames_Initilise(frame, frame.partyID)
			if UnitExists("partypet"..frame:GetID()) then
				AuraUnitFrames_Initilise(_G["AuraUnitFrames_PartyPet"..frame:GetID().."Frame"], "partypet"..frame:GetID())
			end
		else
			--unit no longer exists so hide the bars and set it to not shown
			frame:SetAlpha(0)
			frame.shown = false
		end
			
	end
end

--override funtions so the game wont show tooltips and bug on hidden frames
function AuraUnitFramesParty_OnEnter(self)
    if self.shown or self:GetParent().shown then
		AuraUnitFrames_OnEnter(self)
	end
end